#include "DEV_Config.h"
#include "Pico_LCD_0in96.h"
#include "GUI_Paint.h"
#include "GUI_BMP.h"
#include "test.h"
#include <stdio.h>		//printf()
#include <stdlib.h>		//exit()
#include <signal.h>     //signal()

void PICO_LCD_0IN96_test(void)
{
    // Exception handling:ctrl + c
    signal(SIGINT, Handler_0IN96_LCD);
    
    /* Module Init */
	if(DEV_ModuleInit() != 0){
        DEV_ModuleExit();
        exit(0);
    }
	
    /* LCD Init */
	printf("0.96inch LCD demo...\r\n");
	PICO_LCD_0IN96_Init();
	PICO_LCD_0IN96_Clear(WHITE);
	//LCD_SetBacklight(1023);
	
    UDOUBLE Imagesize = PICO_LCD_0IN96_HEIGHT*PICO_LCD_0IN96_WIDTH*2;
    UWORD *BlackImage;
    if((BlackImage = (UWORD *)malloc(Imagesize)) == NULL) {
        printf("Failed to apply for black memory...\r\n");
        exit(0);
    }
	
    /*1.Create a new image cache named IMAGE_RGB and fill it with white*/
    Paint_NewImage(BlackImage, PICO_LCD_0IN96_WIDTH, PICO_LCD_0IN96_HEIGHT, 0, WHITE, 16);
    Paint_Clear(WHITE);
	//Paint_SetRotate(ROTATE_180);
	
    /* GUI */
    printf("drawing...\r\n");
    /*2.Drawing on the image*/
	Paint_DrawPoint(2,1, BLACK, DOT_PIXEL_1X1,  DOT_FILL_RIGHTUP);
	Paint_DrawPoint(2,6, BLACK, DOT_PIXEL_2X2,  DOT_FILL_RIGHTUP);
	Paint_DrawPoint(2,11, BLACK, DOT_PIXEL_3X3, DOT_FILL_RIGHTUP);
	Paint_DrawPoint(2,16, BLACK, DOT_PIXEL_4X4, DOT_FILL_RIGHTUP);
	Paint_DrawPoint(2,21, BLACK, DOT_PIXEL_5X5, DOT_FILL_RIGHTUP);
	Paint_DrawLine( 10,  5, 40, 35, MAGENTA, DOT_PIXEL_2X2, LINE_STYLE_SOLID);
	Paint_DrawLine( 10, 35, 40,  5, MAGENTA, DOT_PIXEL_2X2, LINE_STYLE_SOLID);

	Paint_DrawLine( 80,  20, 110, 20, BLACK, DOT_PIXEL_1X1, LINE_STYLE_DOTTED);
	Paint_DrawLine( 95,   5,  95, 35, BLACK, DOT_PIXEL_1X1, LINE_STYLE_DOTTED);

	Paint_DrawRectangle(10, 5, 40, 35, RED, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
	Paint_DrawRectangle(45, 5, 75, 35, BLUE, DOT_PIXEL_2X2,DRAW_FILL_FULL);

	Paint_DrawCircle( 95,20, 15, RED  ,DOT_PIXEL_1X1,DRAW_FILL_EMPTY);
	Paint_DrawCircle(130,20, 15, GREEN   ,DOT_PIXEL_1X1,DRAW_FILL_FULL);
	
	Paint_DrawFloatNum (23, 37 ,987.654321,3, &Font12,  0x000f,  0xfff0);
	Paint_DrawString_EN(1, 37, "ABC", &Font12, 0x000f, 0xfff0);
	Paint_DrawString_CN(1,43, "幸狐科技",  &Font24CN, WHITE, BLUE);
	   
    /*3.Refresh the picture in RAM to LCD*/
    PICO_LCD_0IN96_Display(BlackImage);
	DEV_Delay_ms(2000);
	
    /* show bmp */
	printf("show bmp\r\n");
	
	GUI_ReadBmp("./pic/PICO_LCD_0inch96.bmp");    
    PICO_LCD_0IN96_Display(BlackImage);
    DEV_Delay_ms(2000);

	/*key*/
    int BL_Value = 500;	
    Paint_Clear(WHITE);
    PICO_LCD_0IN96_Display(BlackImage);
	while(1)
	{
		Paint_DrawRectangle(40,30,65,50, BLUE, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
		Paint_DrawRectangle(70,0,90,25, BLUE, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
		Paint_DrawRectangle(95,30,120,50, BLUE, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
		Paint_DrawRectangle(70,55,90,80, BLUE, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
		
		Paint_DrawRectangle(139,1,159,26, BLUE, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
		Paint_DrawRectangle(139,54,159,79, BLUE, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
		
		Paint_DrawCircle( 80,40,15, RED  ,DOT_PIXEL_2X2,DRAW_FILL_EMPTY);				
		if(GET_KEY_LEFT == 0){
			Paint_DrawRectangle(40,30,65,50, BLUE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
		}else{
			Paint_DrawRectangle(43,33,62,47, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);	
		}
		if(GET_KEY_UP == 0){
			Paint_DrawRectangle(70,0,90,25, BLUE, DOT_PIXEL_2X2,DRAW_FILL_FULL);				
		}else{
			Paint_DrawRectangle(73,3,87,22, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
		}
		if(GET_KEY_RIGHT == 0){
			Paint_DrawRectangle(95,30,120,50, BLUE, DOT_PIXEL_2X2,DRAW_FILL_FULL);				
		}else{
			Paint_DrawRectangle(98,33,117,47, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);	
		}
		if(GET_KEY_DOWN == 0){
			Paint_DrawRectangle(70,55,90,80, BLUE, DOT_PIXEL_2X2,DRAW_FILL_FULL);				
		}else{
			Paint_DrawRectangle(73,58,87,77, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);	
		}
		if(GET_KEY_PRESS == 0){
			Paint_DrawCircle( 80,40,15, RED ,DOT_PIXEL_2X2,DRAW_FILL_FULL);
		}else{
			Paint_DrawCircle( 80,40,12, WHITE ,DOT_PIXEL_2X2,DRAW_FILL_FULL);	
		}	
		
		if(GET_KEY1 == 0)
		{	
			Paint_DrawRectangle(139,1,159,26, BLUE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
			BL_Value+=100;
			if(BL_Value>=1023)
			{
				BL_Value=1023;
			}
		}else{
			Paint_DrawRectangle(142,4,156,23, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
		}
		if(GET_KEY2 == 0)
		{
			Paint_DrawRectangle(139,54,159,79, BLUE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
			BL_Value-=100;
			if(BL_Value<=0)
			{
				BL_Value=0;
			}
		}else{
			Paint_DrawRectangle(142,57,156,76, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
		}
		DEV_SetBacklight(BL_Value);
		PICO_LCD_0IN96_Display(BlackImage);
	}

    /* Module Exit */
    free(BlackImage);
    BlackImage = NULL;
	DEV_ModuleExit();
}

