#include "DEV_Config.h"
#include "Pico_LCD_1in3.h"
#include "GUI_Paint.h"
#include "GUI_BMP.h"
#include "test.h"
#include <stdio.h>		//printf()
#include <stdlib.h>		//exit()
#include <signal.h>     //signal()

void PICO_LCD_1IN3_test(void)
{
    // Exception handling:ctrl + c
    signal(SIGINT, Handler_1IN3_LCD);
    
    /* Module Init */
	if(DEV_ModuleInit() != 0){
        DEV_ModuleExit();
        exit(0);
    }
	
    /* LCD Init */
	printf("1.3inch LCD demo...\r\n");
	PICO_LCD_1IN3_Init(HORIZONTAL);
	PICO_LCD_1IN3_Clear(WHITE);
    //LCD_SetBacklight(1023);
	
    UWORD *BlackImage;
    UDOUBLE Imagesize = PICO_LCD_1IN3_HEIGHT*PICO_LCD_1IN3_WIDTH*2;
    printf("Imagesize = %d\r\n", Imagesize);
    if((BlackImage = (UWORD *)malloc(Imagesize)) == NULL) {
        printf("Failed to apply for black memory...\r\n");
        exit(0);
    }
    /*1.Create a new image cache named IMAGE_RGB and fill it with white*/
    Paint_NewImage(BlackImage, PICO_LCD_1IN3_WIDTH, PICO_LCD_1IN3_HEIGHT, 0, WHITE, 16);
    Paint_Clear(WHITE);
	Paint_SetRotate(ROTATE_0);
    /* GUI */
    printf("drawing...\r\n");
    /*2.Drawing on the image*/
    Paint_DrawPoint(5, 10, BLACK, DOT_PIXEL_1X1, DOT_STYLE_DFT);
    Paint_DrawPoint(5, 25, BLACK, DOT_PIXEL_2X2, DOT_STYLE_DFT);
    Paint_DrawPoint(5, 40, BLACK, DOT_PIXEL_3X3, DOT_STYLE_DFT);
    Paint_DrawPoint(5, 55, BLACK, DOT_PIXEL_4X4, DOT_STYLE_DFT);

    Paint_DrawLine(20, 10, 70, 60, RED, DOT_PIXEL_1X1, LINE_STYLE_SOLID);
    Paint_DrawLine(70, 10, 20, 60, RED, DOT_PIXEL_1X1, LINE_STYLE_SOLID);
    Paint_DrawLine(170, 15, 170, 55, RED, DOT_PIXEL_1X1, LINE_STYLE_DOTTED);
    Paint_DrawLine(150, 35, 190, 35, RED, DOT_PIXEL_1X1, LINE_STYLE_DOTTED);

    Paint_DrawRectangle(20, 10, 70, 60, BLUE, DOT_PIXEL_1X1, DRAW_FILL_EMPTY);
    Paint_DrawRectangle(85, 10, 130, 60, BLUE, DOT_PIXEL_1X1, DRAW_FILL_FULL);

    Paint_DrawCircle(170, 35, 20, GREEN, DOT_PIXEL_1X1, DRAW_FILL_EMPTY);
    Paint_DrawCircle(170, 85, 20, GREEN, DOT_PIXEL_1X1, DRAW_FILL_FULL);

    Paint_DrawString_EN(5, 70, "hello world", &Font16, WHITE, BLACK);
    Paint_DrawString_EN(5, 90, "luckfox", &Font20, RED, IMAGE_BACKGROUND);

    Paint_DrawNum(5, 160, 123456789, &Font20, GREEN, IMAGE_BACKGROUND);
	Paint_DrawString_CN(5,200, "ҺƼ",  &Font24CN,IMAGE_BACKGROUND,BLUE);   
        
    /*3.Refresh the picture in RAM to LCD*/
    PICO_LCD_1IN3_Display(BlackImage);
    DEV_Delay_ms(2000);
    
    /* show bmp */
	printf("show bmp\r\n");
	GUI_ReadBmp("./pic/PICO_LCD_1inch3.bmp");
    
    PICO_LCD_1IN3_Display(BlackImage);
    DEV_Delay_ms(2000);

    /*key*/
    Paint_Clear(WHITE);
    Paint_DrawRectangle(208, 15, 237, 45, 0xF800, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
    Paint_DrawRectangle(208, 75, 237, 105, 0xF800, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
    Paint_DrawRectangle(208, 135, 237, 165, 0xF800, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
    Paint_DrawRectangle(208, 195, 237, 225, 0xF800, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
    Paint_DrawRectangle(60, 60, 91, 90, 0xF800, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
    Paint_DrawRectangle(60, 150, 91, 180, 0xF800, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
    Paint_DrawRectangle(15, 105, 46, 135, 0xF800, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
    Paint_DrawRectangle(105, 105, 136, 135, 0xF800, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
    Paint_DrawRectangle(60, 105, 91, 135, 0xF800, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
    PICO_LCD_1IN3_Display(BlackImage);

    while(1){
        if(GET_KEYA == 0){
            Paint_DrawRectangle(208, 15, 236, 45, RED, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(208, 15, 236, 45,BlackImage);
            printf("gpio =%d\r\n",KEYA_PIN);
        }
        else{
            Paint_DrawRectangle(208, 15, 236, 45, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(208, 15, 236, 45,BlackImage);
        }
            
        if(GET_KEYB == 0){
            Paint_DrawRectangle(208, 75, 236, 105, RED, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(208, 75, 236, 105,BlackImage);
            printf("gpio =%d\r\n",KEYB_PIN);
        }
        else{
            Paint_DrawRectangle(208, 75, 236, 105, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(208, 75, 236, 105,BlackImage);
        }
        
        if(GET_KEYX == 0){
            Paint_DrawRectangle(208, 135, 236, 165, RED, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(208, 135, 236, 165,BlackImage);
            printf("gpio =%d\r\n",KEYX_PIN);
        }
        else{
            Paint_DrawRectangle(208, 135, 236, 165, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(208, 135, 236, 165,BlackImage);
        }
            
        if(GET_KEYY == 0){
            Paint_DrawRectangle(208, 195, 236, 225, RED, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(208, 195, 236, 225,BlackImage);
            printf("gpio =%d\r\n",KEYY_PIN);
        }
        else{
            Paint_DrawRectangle(208, 195, 236, 225, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(208, 195, 236, 225,BlackImage);
        }


        if(GET_KEY_UP == 0){
            Paint_DrawRectangle(60, 60, 90, 90, RED, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(60, 60, 90, 90,BlackImage);
            printf("gpio =%d\r\n",KEY_UP_PIN);
        }
        else{
            Paint_DrawRectangle(60, 60, 90, 90, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(60, 60, 90, 90,BlackImage);
        }

        if(GET_KEY_DOWN == 0){
            Paint_DrawRectangle(60, 150, 90, 180, RED, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(60, 150, 90, 180,BlackImage);
            printf("gpio =%d\r\n",KEY_DOWN_PIN);
        }
        else{
            Paint_DrawRectangle(60, 150, 90, 180, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(60, 150, 90, 180,BlackImage);
        }
        
        if(GET_KEY_LEFT == 0){
            Paint_DrawRectangle(15, 105, 45, 135, RED, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(15, 105, 45, 135,BlackImage);
            printf("gpio =%d\r\n",KEY_LEFT_PIN);
        }
        else{
            Paint_DrawRectangle(15, 105, 45, 135, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(15, 105, 45, 135,BlackImage);
        }
            
        if(GET_KEY_RIGHT == 0){
            Paint_DrawRectangle(105, 105, 135, 135, RED, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(105, 105, 135, 135,BlackImage);
            printf("gpio =%d\r\n",KEY_RIGHT_PIN);
        }
        else{
            Paint_DrawRectangle(105, 105, 135, 135, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(105, 105, 135, 135,BlackImage);
        }
        
        if(GET_KEY_PRESS == 0){
            Paint_DrawRectangle(60, 105, 90, 135, RED, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(60, 105, 90, 135,BlackImage);
            printf("gpio =%d\r\n",KEY_PRESS_PIN);
        }
        else{
            Paint_DrawRectangle(60, 105, 90, 135, WHITE, DOT_PIXEL_2X2,DRAW_FILL_FULL);
            PICO_LCD_1IN3_DisplayWindows(60, 105, 90, 135,BlackImage);
        }
    }
    
    /* Module Exit */
    free(BlackImage);
    BlackImage = NULL;
	DEV_ModuleExit();
}

