#include "DEV_Config.h"
#include "Pico_LCD_1in44.h"
#include "GUI_Paint.h"
#include "GUI_BMP.h"
#include "test.h"
#include <stdio.h>		//printf()
#include <stdlib.h>		//exit()
#include <signal.h>     //signal()

void PICO_LCD_1IN44_test(void)
{
    // Exception handling:ctrl + c
    signal(SIGINT, Handler_1IN44_LCD);
    
    /* Module Init */
	if(DEV_ModuleInit() != 0){
        DEV_ModuleExit();
        exit(0);
    }
	
    /* LCD Init */
	printf("1.44inch LCD demo...\r\n");
	PICO_LCD_1IN44_Init(HORIZONTAL);
	PICO_LCD_1IN44_Clear(WHITE);
    //LCD_SetBacklight(1023);
	
    UWORD *BlackImage;
    UDOUBLE Imagesize = PICO_LCD_1IN44_HEIGHT*PICO_LCD_1IN44_WIDTH*2;
    printf("Imagesize = %d\r\n", Imagesize);
    if((BlackImage = (UWORD *)malloc(Imagesize)) == NULL) {
        printf("Failed to apply for black memory...\r\n");
        exit(0);
    }
    /*1.Create a new image cache named IMAGE_RGB and fill it with white*/
    Paint_NewImage(BlackImage, PICO_LCD_1IN44_WIDTH, PICO_LCD_1IN44_HEIGHT, 0, WHITE, 16);
    Paint_Clear(WHITE);
	Paint_SetRotate(ROTATE_0);
    /* GUI */
    printf("drawing...\r\n");
    /*2.Drawing on the image*/
    Paint_DrawPoint(104,9, BLACK, DOT_PIXEL_1X1,  DOT_FILL_RIGHTUP);
    Paint_DrawPoint(107,8, BLACK, DOT_PIXEL_2X2,  DOT_FILL_RIGHTUP);
    Paint_DrawPoint(111,7, BLACK, DOT_PIXEL_3X3, DOT_FILL_RIGHTUP);
    Paint_DrawPoint(116,6, BLACK, DOT_PIXEL_4X4, DOT_FILL_RIGHTUP);
    Paint_DrawPoint(122,5, BLACK, DOT_PIXEL_5X5, DOT_FILL_RIGHTUP);
    
	Paint_DrawLine( 10,  10, 40, 40, MAGENTA, DOT_PIXEL_2X2, LINE_STYLE_SOLID);
    Paint_DrawLine( 10, 40, 40,  10, MAGENTA, DOT_PIXEL_2X2, LINE_STYLE_SOLID);

    Paint_DrawLine( 80,  25, 110, 25, CYAN, DOT_PIXEL_1X1, LINE_STYLE_DOTTED);
    Paint_DrawLine( 95,   10,  95, 40, CYAN, DOT_PIXEL_1X1, LINE_STYLE_DOTTED);

    Paint_DrawRectangle(10, 10, 40, 40, RED, DOT_PIXEL_2X2,DRAW_FILL_EMPTY);
    Paint_DrawRectangle(45, 10, 75, 40, BLUE, DOT_PIXEL_2X2,DRAW_FILL_FULL);

    Paint_DrawCircle(95, 25, 15, GREEN, DOT_PIXEL_1X1, DRAW_FILL_EMPTY);
    
    Paint_DrawString_CN(0,45, "ҺƼ",  &Font24CN,BLACK,BLUE);   
    Paint_DrawString_EN(0, 90, "Pico-LCD-1.44", &Font12, WHITE, BLUE);
    Paint_DrawString_EN (0,100 ,"128x128 Pixels", &Font12, WHITE,  BLACK);
    Paint_DrawString_EN(0, 110, "ST7735S Controller", &Font12, RED, WHITE); 
        
    /*3.Refresh the picture in RAM to LCD*/
    PICO_LCD_1IN44_Display(BlackImage);
    DEV_Delay_ms(2000);
    
    /* show bmp */
	printf("show bmp\r\n");
	GUI_ReadBmp("./pic/PICO_LCD_1inch44.bmp");
    
    PICO_LCD_1IN44_Display(BlackImage);
    DEV_Delay_ms(2000);

    /*key*/
    Paint_Clear(WHITE);
    PICO_LCD_1IN44_Display(BlackImage);
    
    while(1){
    	Paint_DrawString_EN(5, 40, " Key     Test", &Font20, WHITE, RED);
        if(GET_KEYA == 0){//KEY3
        	Paint_DrawRectangle(88, 98, 123, 128, YELLOW, DOT_PIXEL_1X1,DRAW_FILL_FULL);
        }else  {
        	Paint_DrawRectangle(88, 98, 123, 128, RED, DOT_PIXEL_1X1,DRAW_FILL_FULL);
        }
            
        if(GET_KEYB == 0){//KEY2
           Paint_DrawRectangle(88, 66, 123, 96, YELLOW, DOT_PIXEL_1X1,DRAW_FILL_FULL);
        }else  {
         	Paint_DrawRectangle(88, 66, 123, 96, RED, DOT_PIXEL_1X1,DRAW_FILL_FULL);
        }

        if(GET_KEY_UP == 0){//KEY1
			Paint_DrawRectangle(88, 34, 123, 64, YELLOW, DOT_PIXEL_1X1,DRAW_FILL_FULL);
        }else  {
        	Paint_DrawRectangle(88, 34, 123, 64, RED, DOT_PIXEL_1X1,DRAW_FILL_FULL);
        }
        
        if(GET_KEY_PRESS == 0){//KEY0
             Paint_DrawRectangle(88, 2, 123, 32, YELLOW, DOT_PIXEL_1X1,DRAW_FILL_FULL);
        }else{
             Paint_DrawRectangle(88, 2, 123, 32, RED, DOT_PIXEL_1X1,DRAW_FILL_FULL);   
        }		
		PICO_LCD_1IN44_Display(BlackImage);             
    }
    
    /* Module Exit */
    free(BlackImage);
    BlackImage = NULL;
	DEV_ModuleExit();
}

